
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Capa_actionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const capa_actions = await db.capa_actions.create(
            {
                id: data.id || undefined,
        
        action_type: data.action_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        due_at: data.due_at
        ||
        null
            ,
            
        completed_at: data.completed_at
        ||
        null
            ,
            
        effectiveness_check_at: data.effectiveness_check_at
        ||
        null
            ,
            
        effectiveness_notes: data.effectiveness_notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await capa_actions.setNonconformance( data.nonconformance || null, {
            transaction,
        });
        
        await capa_actions.setOwner( data.owner || null, {
            transaction,
        });
        
        await capa_actions.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.capa_actions.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: capa_actions.id,
            },
            data.attachments,
            options,
        );
        

        return capa_actions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const capa_actionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                action_type: item.action_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                due_at: item.due_at
            ||
            null
            ,
            
                completed_at: item.completed_at
            ||
            null
            ,
            
                effectiveness_check_at: item.effectiveness_check_at
            ||
            null
            ,
            
                effectiveness_notes: item.effectiveness_notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const capa_actions = await db.capa_actions.bulkCreate(capa_actionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < capa_actions.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.capa_actions.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: capa_actions[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return capa_actions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const capa_actions = await db.capa_actions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.action_type !== undefined) updatePayload.action_type = data.action_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.due_at !== undefined) updatePayload.due_at = data.due_at;
        
        
        if (data.completed_at !== undefined) updatePayload.completed_at = data.completed_at;
        
        
        if (data.effectiveness_check_at !== undefined) updatePayload.effectiveness_check_at = data.effectiveness_check_at;
        
        
        if (data.effectiveness_notes !== undefined) updatePayload.effectiveness_notes = data.effectiveness_notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await capa_actions.update(updatePayload, {transaction});

        
        
        if (data.nonconformance !== undefined) {
            await capa_actions.setNonconformance(
              
              data.nonconformance,
              
              { transaction }
            );
        }
        
        if (data.owner !== undefined) {
            await capa_actions.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await capa_actions.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.capa_actions.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: capa_actions.id,
            },
            data.attachments,
            options,
        );
        

        return capa_actions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const capa_actions = await db.capa_actions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of capa_actions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of capa_actions) {
                await record.destroy({transaction});
            }
        });


        return capa_actions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const capa_actions = await db.capa_actions.findByPk(id, options);

        await capa_actions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await capa_actions.destroy({
            transaction
        });

        return capa_actions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const capa_actions = await db.capa_actions.findOne(
            { where },
            { transaction },
        );

        if (!capa_actions) {
            return capa_actions;
        }

        const output = capa_actions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.nonconformance = await capa_actions.getNonconformance({
            transaction
        });
        
        
        output.owner = await capa_actions.getOwner({
            transaction
        });
        
        
        output.attachments = await capa_actions.getAttachments({
            transaction
        });
        
        
        output.organizations = await capa_actions.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.nonconformances,
        as: 'nonconformance',
        
        where: filter.nonconformance ? {
          [Op.or]: [
            { id: { [Op.in]: filter.nonconformance.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.nonconformance.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'capa_actions',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'capa_actions',
                        'description',
                        filter.description,
                    ),
                };
            }
            
            if (filter.effectiveness_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'capa_actions',
                        'effectiveness_notes',
                        filter.effectiveness_notes,
                    ),
                };
            }
            

            
            

            
            if (filter.due_atRange) {
                const [start, end] = filter.due_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.completed_atRange) {
                const [start, end] = filter.completed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.effectiveness_check_atRange) {
                const [start, end] = filter.effectiveness_check_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    effectiveness_check_at: {
                    ...where.effectiveness_check_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    effectiveness_check_at: {
                    ...where.effectiveness_check_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.action_type) {
                where = {
                    ...where,
                action_type: filter.action_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.capa_actions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'capa_actions',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.capa_actions.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

